/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
export * as annotations from './annotations';
export * as apiService from './api-service';
export * as apiServiceV1 from './api-service-v1';
export * as certificateSigningRequest from './certificate-signing-request';
export * as certificateSigningRequestV1 from './certificate-signing-request-v1';
export * as clusterRole from './cluster-role';
export * as clusterRoleBinding from './cluster-role-binding';
export * as clusterRoleBindingV1 from './cluster-role-binding-v1';
export * as clusterRoleV1 from './cluster-role-v1';
export * as configMap from './config-map';
export * as configMapV1 from './config-map-v1';
export * as configMapV1Data from './config-map-v1-data';
export * as cronJob from './cron-job';
export * as cronJobV1 from './cron-job-v1';
export * as csiDriver from './csi-driver';
export * as csiDriverV1 from './csi-driver-v1';
export * as daemonSetV1 from './daemon-set-v1';
export * as daemonset from './daemonset';
export * as defaultServiceAccount from './default-service-account';
export * as defaultServiceAccountV1 from './default-service-account-v1';
export * as deployment from './deployment';
export * as deploymentV1 from './deployment-v1';
export * as endpointSliceV1 from './endpoint-slice-v1';
export * as endpoints from './endpoints';
export * as endpointsV1 from './endpoints-v1';
export * as env from './env';
export * as horizontalPodAutoscaler from './horizontal-pod-autoscaler';
export * as horizontalPodAutoscalerV1 from './horizontal-pod-autoscaler-v1';
export * as horizontalPodAutoscalerV2 from './horizontal-pod-autoscaler-v2';
export * as horizontalPodAutoscalerV2Beta2 from './horizontal-pod-autoscaler-v2beta2';
export * as ingress from './ingress';
export * as ingressClass from './ingress-class';
export * as ingressClassV1 from './ingress-class-v1';
export * as ingressV1 from './ingress-v1';
export * as job from './job';
export * as jobV1 from './job-v1';
export * as labels from './labels';
export * as limitRange from './limit-range';
export * as limitRangeV1 from './limit-range-v1';
export * as manifest from './manifest';
export * as mutatingWebhookConfiguration from './mutating-webhook-configuration';
export * as mutatingWebhookConfigurationV1 from './mutating-webhook-configuration-v1';
export * as namespace from './namespace';
export * as namespaceV1 from './namespace-v1';
export * as networkPolicy from './network-policy';
export * as networkPolicyV1 from './network-policy-v1';
export * as nodeTaint from './node-taint';
export * as persistentVolume from './persistent-volume';
export * as persistentVolumeClaim from './persistent-volume-claim';
export * as persistentVolumeClaimV1 from './persistent-volume-claim-v1';
export * as persistentVolumeV1 from './persistent-volume-v1';
export * as pod from './pod';
export * as podDisruptionBudget from './pod-disruption-budget';
export * as podDisruptionBudgetV1 from './pod-disruption-budget-v1';
export * as podSecurityPolicy from './pod-security-policy';
export * as podSecurityPolicyV1Beta1 from './pod-security-policy-v1beta1';
export * as podV1 from './pod-v1';
export * as priorityClass from './priority-class';
export * as priorityClassV1 from './priority-class-v1';
export * as replicationController from './replication-controller';
export * as replicationControllerV1 from './replication-controller-v1';
export * as resourceQuota from './resource-quota';
export * as resourceQuotaV1 from './resource-quota-v1';
export * as role from './role';
export * as roleBinding from './role-binding';
export * as roleBindingV1 from './role-binding-v1';
export * as roleV1 from './role-v1';
export * as runtimeClassV1 from './runtime-class-v1';
export * as secret from './secret';
export * as secretV1 from './secret-v1';
export * as service from './service';
export * as serviceAccount from './service-account';
export * as serviceAccountV1 from './service-account-v1';
export * as serviceV1 from './service-v1';
export * as statefulSet from './stateful-set';
export * as statefulSetV1 from './stateful-set-v1';
export * as storageClass from './storage-class';
export * as storageClassV1 from './storage-class-v1';
export * as tokenRequestV1 from './token-request-v1';
export * as validatingWebhookConfiguration from './validating-webhook-configuration';
export * as validatingWebhookConfigurationV1 from './validating-webhook-configuration-v1';
export * as dataKubernetesAllNamespaces from './data-kubernetes-all-namespaces';
export * as dataKubernetesConfigMap from './data-kubernetes-config-map';
export * as dataKubernetesConfigMapV1 from './data-kubernetes-config-map-v1';
export * as dataKubernetesEndpointsV1 from './data-kubernetes-endpoints-v1';
export * as dataKubernetesIngress from './data-kubernetes-ingress';
export * as dataKubernetesIngressV1 from './data-kubernetes-ingress-v1';
export * as dataKubernetesMutatingWebhookConfigurationV1 from './data-kubernetes-mutating-webhook-configuration-v1';
export * as dataKubernetesNamespace from './data-kubernetes-namespace';
export * as dataKubernetesNamespaceV1 from './data-kubernetes-namespace-v1';
export * as dataKubernetesNodes from './data-kubernetes-nodes';
export * as dataKubernetesPersistentVolumeClaim from './data-kubernetes-persistent-volume-claim';
export * as dataKubernetesPersistentVolumeClaimV1 from './data-kubernetes-persistent-volume-claim-v1';
export * as dataKubernetesPersistentVolumeV1 from './data-kubernetes-persistent-volume-v1';
export * as dataKubernetesPod from './data-kubernetes-pod';
export * as dataKubernetesPodV1 from './data-kubernetes-pod-v1';
export * as dataKubernetesResource from './data-kubernetes-resource';
export * as dataKubernetesResources from './data-kubernetes-resources';
export * as dataKubernetesSecret from './data-kubernetes-secret';
export * as dataKubernetesSecretV1 from './data-kubernetes-secret-v1';
export * as dataKubernetesService from './data-kubernetes-service';
export * as dataKubernetesServiceAccount from './data-kubernetes-service-account';
export * as dataKubernetesServiceAccountV1 from './data-kubernetes-service-account-v1';
export * as dataKubernetesServiceV1 from './data-kubernetes-service-v1';
export * as dataKubernetesStorageClass from './data-kubernetes-storage-class';
export * as dataKubernetesStorageClassV1 from './data-kubernetes-storage-class-v1';
export * as provider from './provider';
